from bitcoding import B_dict
from basesplit import bsplit as split
from inverse import inv
from solve import solve
from hornsplit import hsplit as split
from vbweights import w
from bitcoding import B_dict
from array import array
from counters import counter
from networkx.algorithms import tree
import networkx
from saturate import saturate

DALL = B_dict['DALL']

cardmult = max(w)

def findDecomposition(ConMatrix, ConMatrixT, neighbors, pc_only):

   frozen = set()

   Vars = len(ConMatrix)
   
   decomposition = []
   
   G = networkx.Graph()
   for i in range(Vars):
      for j in range(i+1,Vars):
         if ConMatrix[i][j] != DALL:
             G.add_edge(i, j, weight=(cardmult*split[ConMatrix[i][j]-1][0] + w[ConMatrix[i][j]-1]))                
         
   Gc = G.copy()  
      
   while True:
       dConMatrix = tuple([c[:] for c in ConMatrixT])
       
       for i,j in G.edges(): break
       
       G.add_edge(i, j, weight=(len(dConMatrix)**2)*(cardmult*split[ConMatrix[i][j]-1][0] + w[ConMatrix[i][j]-1]))       
       T = tree.maximum_spanning_tree(G, algorithm="kruskal")
       G.remove_edge(i, j)
       
       for m,n in T.edges():
          dConMatrix[m][n] = ConMatrix[m][n]
          dConMatrix[n][m] = ConMatrix[n][m]      

       considered = saturate(ConMatrix, dConMatrix, set(networkx.difference(Gc, T).edges()), decomposition, neighbors, pc_only)
       
       decomposition.append(tuple([c[:] for c in dConMatrix]))
       
       G.remove_edges_from(considered)
       G.remove_edges_from(T.edges())
       
       if not G.edges(): return decomposition

   raise RuntimeError("Can't happen")  
