from bitcoding import B_dict
from basesplit import bsplit as split
from inverse import inv
from solve import solve
from counters import counter

DALL = B_dict['DALL']

def saturate(ConMatrix, dConMatrix, constraintBag, decomposition, neighbors, pc_only):

   Vars = len(ConMatrix)

   considered = set()
   
   constraintList = []
   if decomposition:
      while constraintBag:
         i,j = constraintBag.pop()
         cc = 0
         for d in decomposition:
            if d[i][j] == ConMatrix[i][j]: cc += 1
         constraintList.append((cc,(i,j)))
      constraintList.sort(reverse=False) # Change to True to maximize similarity

      for i in range(len(constraintList)):
         constraintList[i] = constraintList[i][-1]   
   else:
      constraintList.extend(list(constraintBag))

   for i,j in constraintList:

      temp_ij = dConMatrix[i][j]
      temp_ji = dConMatrix[j][i]
      dConMatrix[i][j] = ConMatrix[i][j]
      dConMatrix[j][i] = ConMatrix[j][i]
      solution, fail = solve(tuple([c[:] for c in dConMatrix]), neighbors, pc_only, set())
      counter['oracle'] += 1

      if solution:
         considered.add((i,j))
      else:
         dConMatrix[i][j] = temp_ij
         dConMatrix[j][i] = temp_ji

   return considered 
